;--------------------------------- ""   ----------------------------------------
;*********************************************************************************************
;   : uzu_40.1 asm          
;      .
;   40   100,   300. 300*3=900m
;   3        5 
;       
;  TMR1 c   1.  .  wdt 128 WDT 
;   :  +     "no SEnSor"
;         
;   40-750 
;           
;         EEPROM 
;    NEW1  PCLATH
;     \ 
;     
;    ( )   "obriv" 
;----------------------------------------------------------------------------------------
; RA0 -  (DB0)
; RA1 -  (DB1)
; RA2 -  (DB2)
; RA3 -  (DB3)
; RA5 - MCLR
; RA6 -  (AO)
; RA7 -  (WR1)
; RB0 -    
; RB1 -  "", "-"
; RB2 -  "", "+"
; RB3 -  
; R4 -      
; R5 -  1 
; RB6 -    (     ) 
; RB7 -  2 
;********************************************************************************************* 
; :   ,  2012.
;*********************************************************************************************
;   PIC16F628A.    4000.
;*********************************************************************************************
;  : 1682    .
;*********************************************************************************************
            LIST       p=16F628A   ;   .
            #include  P16F628A.inc
            errorlevel  2    
            __CONFIG   03F18H      ;  .
;===============================================================================================
;       .
;==============================================================================================
Mem         equ         20h         ;   .
SecH        equ         21h         ;   
SecL        equ         22h         ;   L  
SecM        equ         23h         ;   M
Niz         equ         24h         ;       
setup       equ         25h         ;      
Memory      equ         26h         ;      "no SenSor"
TempD1      equ         27h         ;    D1    
TempD3      equ         28h         ;    D3
Sensor      equ         29h         ;      ,4
rezervuarL  equ         2Ah         ;    
rezervuarM  equ         2Bh         ;    
d0          equ         2Ch         ;      d0
d1          equ         2Dh         ;      d1
vichitL     equ         2Eh         ;  L-     "+" "-"
vichitM     equ         2Fh         ;   -     "+" "-"

Temp        equ         30h         ;    .
Index       equ         31h         ;      .
TimM        equ         32h         ;       
Uup2M       equ         33h         ;   2  ()
Uup1M       equ         34h         ;   1  ()
temd1       equ         35h         ;   d1
temd2       equ         36h         ;   d2
temd3       equ         37h         ;   d3
EEE         equ         38h         ;     "-"
ABD         equ         39h         ;            
temd6       equ         3Ah         ;   d6
temd7       equ         3Bh         ;   d7
temd8       equ         3Ch         ;   d8
Sensor1     equ         3Dh         ;      "no SenSor"
ABC         equ         3Eh         ;        0
Flag        equ         3Fh         ;   

Del         equ         40h         ;      
RegL        equ         41h         ;        
RegH        equ         42h         ;       
Rezult_L    equ         43h         ;       
Rezult_H    equ         44h         ;       
RegM        equ         45h         ;       
Slog_L      equ         46h         ;       50 
Slog_M      equ         47h         ;       50 
CntDiv      equ         48h         ;      
Temp1       equ         49h         ;    1        
Temp2       equ         4Ah         ;    2 
Temp3       equ         4Bh         ;    3 
Count2      equ         4Ch         ;   
nakopitL    equ         4Dh         ;       
nakopitM    equ         4Eh         ;       
Coun        equ         4Fh         ;      .

d2          equ         50h         ;      d2 
d3          equ         51h         ;      d3
d4          equ         52h         ;      d4
d5          equ         53h         ;      d5
d6          equ         54h         ;      d6
d7          equ         55h         ;      d7
d8          equ         56h         ;      d8
d9          equ         57h         ;      d9
impuls1L    equ         58h         ;  1-         
impuls1M    equ         59h         ;  1-         
temd4       equ         5Ah         ;   d4
temd5       equ         5Bh         ;   d5
TTL         equ         5Ch         ;    TimerL
TTM         equ         5Dh         ;    TimerM
umenL       equ         5Eh         ;  L-     "+" "-" 
umenM       equ         5Fh         ;  -     "+" "-"

signal	equ	60h
Flag1       equ         61h         ;   

LED0        equ         70h         ;    
LED1        equ         71h         ; ------- 2- -------------------------
LED2        equ         72h         ; ------- 3- -------------------------
TimerL      equ         73h         ;    3-  .
TimerM      equ         74h         ;    3-  .
Udn2L       equ         75h         ;   2  ()
Stat_Temp   equ         76h         ;      Status
W_Temp      equ         77h         ;      W
Udn1L       equ         78h         ;   1  ()
Uup1L       equ         79h         ;   1  ()
TimerH      equ         7Ah         ;  c  3-  .
Count       equ         7Bh         ;        -.
TimL        equ         7Ch         ;       
Uup2L       equ         7Dh         ;   1  ()
Udn1M       equ         7Eh         ;   1  ()
Udn2M       equ         7Fh         ;   2  ()
;===============================================================================================
;     .
;===============================================================================================
W           equ         0           ;    .
F           equ         1           ;    .
;===============================================================================================
;   .
;===============================================================================================
C           equ         0           ;  -.
Z           equ         2           ;   .
;===============================================================================================
;=============================================================================================
;     .
;=============================================================================================
            org         2100h       ;   EEPROM  .
            DE          .0,.130,.150;    0,1,2  Udn1M, Uup1L, Udn1L
            DE          .0,.125,.150;    3,4,5  Udn2M, Uup2L, Udn2L
            DE          .0,.0,.0    ;    6,7,8  setup, Uup1M, Uup2M, 
            DE          .144,.1     ;    9,10   rezervuarL, rezervuarM
            org         0           ;   
            goto        START       ;   START
;================================================================================
;    .
;================================================================================
            org         4           ;    (,
                                    ;     ).
;********************************************************************************
;  .
;================================================================================           
;    STATUS  W  .
;--------------------------------------------------------------------------------
INT         movwf       W_Temp      ;    W  W_Temp.
            movf        Status,W    ;    Status W
            movwf       Stat_Temp   ;   W  Stat_Temp.
            clrf        IntCon      ;  IntCon 
            bcf         T1CON,0     ;  TMR1
            movf        TMR1L,W     ; -----------------------------------------
            movwf       RegL        ;   TMR1  Reg 
            movf        TMR1H,W     ;   TMR1     59
            movwf       RegH        ;       
            movlw       0x3B        ;     59
            movwf       Del         ;
;=============================================================================================
;   .
;=============================================================================================
            clrf        Temp1       ;   0   Temp1.
            clrf        Temp2       ;   0   Temp2.
            clrf        Count2      ;   0   Count.
            clrf        Rezult_L    ;   0   Rezult_L.
            clrf        Rezult_H    ;   0   Rezult_H.
            movlw       .4          ;   .4
            movwf       CntDiv      ;   CntDiv.
;=============================================================================================
;  .
;=============================================================================================
START_DIV   call        MINUS       ;      MINUS.
;---->      MINUS.
            btfsc       Flag,0      ;   .
            goto        PLUS        ;    (1),     PLUS.
            incf        Count2,F    ;    (0),  Count+1=...  -  Count.
            goto        START_DIV   ;    START_DIV.
;------------------------------------------------
PLUS        movf        Del,W       ;
            addwf       Temp1,F     ; Del_L + Temp1 = ...
            btfsc       Status,0    ;     ?
            incf        Temp2,F     ;    (=1),  Temp2+1=?  -  Temp2.
            bcf         Status,0    ;     (=0),    .
            rrf         CntDiv,W    ;    CntDiv.  -  W.
            movwf       FSR         ;       ,
                                    ;   FSR ( W).
            movlw       Rezult_L    ;   W   Rezult_L.
            addwf       FSR,F       ; FSR + W = ...  -  FSR.
            btfss       CntDiv,0    ;  0  CntDiv =0  =1 ?
            goto        NNH         ;  =0,     NNH.
            swapf       Count2,W    ;  =0,   /  Count.  -  W.
            iorwf       Indf,F      ; ""  W      FSR. 
                                    ; -      FSR.
            goto        FFF         ;    FFF.
;--------------------------------------------------
NNH         movf        Count2,W    ;   Count  W.
            iorwf       Indf,F      ; ""  W      SFR. 
                                    ; -      FSR.
;--------------------------------------------------
;    ?
;--------------------------------------------------
FFF         decf        CntDiv,F    ; CntDiv - 1 = ...  -  CntDiv.
            movlw       b'11111111' ;
            subwf       CntDiv,W    ; CntDiv - FFh = ...  -  W.
            btfsc       Status,2    ;   =0  =0 ?
            goto        FINAL       ;  =0,     FINAL.
                                    ;  =0,    . 
;------------------------------------------------------
; 4   Temp1/Temp2    .
;------------------------------------------------------
NO_FIN      bcf         Status,0    ;   0  .
            rlf         Temp1,F     ;    2- 
            rlf         Temp2,F     ;  Temp1/Temp2.

            bcf         Status,0    ;   0  .
            rlf         Temp1,F     ; ----------"----------
            rlf         Temp2,F     ;    (2).

            bcf         Status,0    ;   0  .
            rlf         Temp1,F     ; ----------"----------
            rlf         Temp2,F     ;    (3).
            bcf         Status,0    ;   0  .
            rlf         Temp1,F     ; ----------"----------
            rlf         Temp2,F     ;    (4).
;---------------------------------------------------
            bcf         Status,0    ;   0  .
            rrf         CntDiv,W    ;    CntDiv.  -  W.
            movwf       FSR         ;   W  FSR.
            movlw       RegL        ;    RegL  W.
            addwf       FSR,F       ; W + FSR = ...  -  FSR.
            btfsc       CntDiv,0    ;  0  CntDiv  0  1 ?
            goto        NNH_1       ;  =1,     NNH_1.
            movlw       b'00001111' ;  =0,    W  0Fh.
            andwf       Indf,W      ;   /   
                                    ;  FSR     W.
            iorwf       Temp1,F     ; ""  W  Temp1.  -  Temp1.
            goto        SNOVA       ;    SNOVA.
;--------------------------------------------------
NNH_1       swapf       Indf,W      ;  /     FSR.  -  W.
            andlw       b'00001111' ;   /  
                                    ; .  -  W.
            iorwf       Temp1,F     ; ""  W  Temp1.  -  Temp1.
;--------------------------------------------------
SNOVA       clrf        Count2      ;   0   Count.
            goto        START_DIV   ;    START_DIV. 
;=============================================================================================
;  .
;=============================================================================================
MINUS       bcf         Flag,0      ;    0.
            movf        Del,W       ; 
            subwf       Temp1,F     ; Temp1 - Del = ...  -  Temp1.
            btfsc       Status,0    ;     ?
;------------------------------------
;  .
;------------------------------------
            return                  ;   (=1),       START_DIV.
                                    ;   (=0),    .
            decf        Temp2,F     ; Temp2 - 1 = ...  -  Temp2.
            movlw       b'11111111' ;
            subwf       Temp2,W     ; Temp2 - FFh = ...
            btfss       Status,2    ;  =0  =0 ?
;------------------------------------
;  .
;------------------------------------
            return                  ;  =0,       START_DIV.
            bsf         Flag,0      ;  =0,    (  1).
;------------------------------------
;  .
;------------------------------------
            return                  ;      START_DIV.
;***************************************************************************************
;***************************************************************************************
;   3       5 
;    3     
;***************************************************************************************
;***************************************************************************************
FINAL       btfsc       Flag,4      ;   4   
            goto        zamer2      ;   ,      1   2-
            movf        Rezult_L,W  ; ---------------------------------------
            movwf       impuls1L    ;
            movwf       umenL       ;
            movf        Rezult_H,W  ;   Rezult  impuls1  umenL 
            movwf       impuls1M    ;
            movwf       umenM       ; ---------------------------------------
            bsf         Flag,4      ;         4  1
            goto        EndInt1     ;  

zamer2      btfsc       Flag,5      ;   1  2  
            goto        IMP3        ;  2     IMP3
            movf        impuls1L,W  ; --------------------------------------------------
            movwf       umenL       ; 
            movf        impuls1M,W  ;      
            movwf       umenM       ;
            movf        Rezult_L,W  ; 1   2
            movwf       vichitL     ;
            movf        Rezult_H,W  ;
            movwf       vichitM     ;
            call        vihit       ; --------------------------------------------------
;--------------------------------------------------------------------------------------- 
            bcf         Status,2    ; --------------------------------------------------
            movf        vichitM,W   ;
            btfss       Status,2    ;
            goto        HET2        ;      5      HET2 
            movf        vichitL,W   ;
            sublw       .5          ;
            btfss       Status,C    ;
            goto        HET2        ; ---------------------------------------------------
            bsf         Flag,5      ;
            movf        impuls1L,W  ;
            movwf       nakopitL    ;
            movf        impuls1M,W  ;     5 
            movwf       nakopitM    ;
            movf        Rezult_L,W  ; 
            addwf       nakopitL,F  ; 
            btfss       Status,C    ;  1  2 
            goto        $+2         ; 
            incf        nakopitM,F  ; 
            movf        Rezult_H,W  ;    
            addwf       nakopitM,F  ; ----------------------------------------------------
            goto        EndInt1     ;   
;----------------------------------------------------------------------------------------- 
HET2        bcf         Flag,5      ;-----------------------------------------------------
            btfsc       Flag,6      ;   2  ,    
            goto        $+3         ;   
            bsf         Flag,6      ; 
            goto        EndInt1     ;            
            bcf         Flag,4      ;
            bcf         Flag,5      ;
            bcf         Flag,6      ; 5 (  1- ),    4,5,6,7
            bcf         Flag,7      ;
            clrf        nakopitL    ;     nakopit
            clrf        nakopitM    ; ----------------------------------------------------------   
            goto        EndInt1     ;   
;--------------------------------------------------------------------------------------------
IMP3        movf        impuls1L,W  ; ------------------------------------------------------
            movwf       umenL       ;  
            movf        impuls1M,W  ; 
            movwf       umenM       ;  
            movf        Rezult_L,W  ;       
            movwf       vichitL     ;
            movf        Rezult_H,W  ;
            movwf       vichitM     ;
            call        vihit       ; --------------------------------------------------------
            bcf         Status,2    ;
            movf        vichitM,W   ; 
            btfss       Status,2    ;
            goto        HET3        ;     5      HET3 
            movf        vichitL,W   ;
            sublw       .5          ;
            btfss       Status,C    ;
            goto        HET3        ; -------------------------------------------------------
            bcf         Flag,1      ; 3         4-7 
            bcf         Flag,4      ;
            bcf         Flag,5      ;  0    (1 +2 )+3 
            bcf         Flag,6      ;
            bcf         Flag,7      ; -------------------------------------------------------
            movf        Rezult_L,W  ; 
            addwf       nakopitL,F  ; 
            btfss       Status,C    ; 
            goto        $+2         ;   
            incf        nakopitM,F  ; 
            movf        Rezult_H,W  ;    
            addwf       nakopitM,F  ; --------------------------------------------------------
;---------------------------------------------------------------------------------------------
            movf        nakopitM,W  ; -------------------------------------------------------- 
	movwf       RegH	;        3
	movf        nakopitL,W  ;      
  	movwf       RegL	;    
	movlw       .3 	; 
	movwf       Del	; --------------------------------------------------------
;---------------------------------------------------------------------------------------------
	clrf        Temp1       ;   0   Temp1.
	clrf        Temp2       ;   0   Temp2.
	clrf        Count       ;   0   Count2.
	clrf        Rezult_L    ;   0   Rezult_L.
	clrf        Rezult_H    ;   0   Rezult_H.
            movlw       .4          ;   .4
	movwf       CntDiv      ;   CntDiv.
START_D     call        MINUSIC     ;      MINUSIC
	btfsc       Flag,0      ;   .
	goto        PLU         ;    (1),     PLU. 
	incf        Count,F     ;    (0),  Count+1=...  -  Count.
	goto        START_D     ;    START_DIV.
;------------------------------------------------
PLU         movf        Del,W       ;
	addwf       Temp1,F     ; Del_L + Temp1 = ...
            btfsc       Status,C    ;     ?
            incf        Temp2,F     ;    (=1),  Temp2+1=?  -  Temp2.
            bcf         Status,C    ;     (=0),    .
	rrf         CntDiv,W    ;    CntDiv.  -  W.
	movwf       FSR         ;       ,
                                    ;   FSR ( W).
	movlw       Rezult_L    ;   W   Rezult_L.
	addwf       FSR,F       ; FSR + W = ...  -  FSR.
	btfss       CntDiv,0    ;  0  CntDiv =0  =1 ?
	goto        HNNH        ;  =0,     HNNH.
	swapf       Count,W     ;  =0,   /  Count.  -  W.
	iorwf       Indf,F      ; ""  W      FSR. 
                                    ; -      FSR.
	goto        FFFF        ;     FFFF.
;--------------------------------------------------
HNNH	movf        Count,W     ;   Count  W.
	iorwf       Indf,F      ; ""  W      SFR. 
FFFF	decf        CntDiv,F    ; -      FSR.
	movlw       b'11111111' ;
	subwf       CntDiv,W    ; CntDiv - FFh = ...  -  W.
            btfsc       Status,Z    ;   =0  =0 ?
            goto        YES_FIN     ;  =0,     YES_FIN.
                                    ;  =0,    .
NO_FINAL    bcf         Status,C    ;   0  .
	rlf         Temp1,F     ;    2- 
	rlf         Temp2,F     ;  Temp1/Temp2.

	bcf         Status,C    ;   0  .
	rlf         Temp1,F     ;  ----------"----------
	rlf         Temp2,F     ;    (2). 

	bcf         Status,C    ;   0  .
	rlf         Temp1,F     ; ----------"----------
	rlf         Temp2,F     ;    (3).

	bcf         Status,C    ;   0  .
	rlf         Temp1,F     ; ----------"----------
	rlf         Temp2,F     ;    (4). 
;---------------------------------------------------
	bcf         Status,C    ;   0  .
	rrf         CntDiv,W    ;    CntDiv.  -  W. 
	movwf       FSR         ;   W  FSR.
	movlw       RegL        ;    RegL  W.
	addwf       FSR,F       ; W + FSR = ...  -  FSR.
	btfsc       CntDiv,0    ;  0  CntDiv  0  1 ?
	goto        HNNH_1      ;  =1,     HNNH_1.
	movlw       b'00001111' ;  =0,    W  0Fh.
	andwf       Indf,W      ;   /   
                                    ;  FSR     W.
	iorwf       Temp1,F     ; ""  W  Temp1.  -  Temp1.
	goto        SNOVAL      ;    SNOVAL
;-------------------------------------------------------------------------------------------
HNNH_1	swapf       Indf,W      ;  /     FSR.  -  W. 
	andlw       b'00001111' ;   /  
                                    ; .  -  W.
	iorwf       Temp1,F     ; ""  W  Temp1.  -  Temp1.
;-------------------------------------------------------------------------------------------
SNOVAL	clrf        Count       ;   0   Count.
	goto        START_D     ;    START_D. 
;--------------------------------------------------------------------------------------------
YES_FIN	bcf         Status,C    ;   0    Status.
	rrf         Del,F       ;    Del
;--------------------------------------------------------------------------------------------
            movf        Temp1,W     ; 
            subwf       Del,W       ; Del - Temp1 = ...  -  W.
            btfsc       Status,C    ;  Status,C
	goto        FINISH      ;  1    FINISH
;----------------------------------------------------------------------------------------------
            incfsz      Rezult_L,F  ;     0
	goto        FINISH      ;   0   FINISH
            incf        Rezult_H,F  ;  0  Rezult_H
;----------------------------------------------------------------------------------------------
FINISH	movf        Rezult_L,W  ; ---------------------------------------------------------
	movwf       TimerL      ;    Rezult   Timer
	movf        Rezult_H,W  ; 
	movwf       TimerM      ;----------------------------------------------------------
            clrf        nakopitL    ;       
            clrf        nakopitM    ;  3 /3=   
            goto        MODE        ;   MODE  
; ---------------------------------------------------------------------------------------------
HET3        btfsc       Flag,7      ;    
            goto        $+3         ;  2   3   
            bsf         Flag,7      ;  1   1  7  
            goto        EndInt      ;   EndInt 
            bcf         Flag,4      ; ---------------------------------------------------------
            bcf         Flag,5      ;
            bcf         Flag,6      ;  2     4-7 
            bcf         Flag,7      ;  
            clrf        nakopitL    ;
            clrf        nakopitM    ;   nakopit    EndInt1  
            goto        EndInt1     ; ----------------------------------------------------------               
;-----------------------------------------------------------------------------------------------
MINUSIC	bcf         Flag,0      ;    0.
	movf        Del,W       ; 
	subwf       Temp1,F     ; Temp1 - Del = ...  -  Temp1.
	btfsc       Status,C    ;     ?
	return                  ; 
;------------------------------------------------------------------------------------------------
	decf        Temp2,F     ; Temp2 - 1 = ...  -  Temp2.
	movlw       b'11111111' ; 
	subwf       Temp2,W     ; Temp2 - FFh = ...
	btfss       Status,Z    ;  =0  =0 ?
	return                  ;  =0,       START_DIV.
	bsf         Flag,0      ;  =0,    (  1).
	return                  ;      START_D.
;==============================================================================================
;              
;==============================================================================================
vihit       comf        umenL,F     ;      RegL  
            incf        umenL,F     ;   .
            btfsc       Status,Z    ;     .
            decf        umenM,F     ;   ,     RegM
                                    ;       RegM.
            comf        umenM,F     ;    ,     
                                    ;   RegM.
            movf        umenL,W     ;    RegL  TimerL
            addwf       vichitL,F   ;      TimerL.
            btfss       Status,C    ;    -.
            goto        MINi        ;    ,     MINUS_1.
            incf        vichitM,F   ;   ,     TimerM.
MINi        movf        umenM,W     ;    RegM  TimerM
            addwf       vichitM,F   ;      TimerM.
            btfsc       Status,C    ;    -.
            goto        $+6         ;   ,     REZ_PLUS.
            comf        vichitL,F   ;      TimerL.
            incf        vichitL,F   ;    .
            btfsc       Status,Z    ;     .
            decf        vichitM,F   ;   ,     TimerM
                                    ;      . 
            comf        vichitM,F   ;     TimerM.
            return

;************************************************************************
;    : - setup,0=0, - setup,0=1
;************************************************************************
MODE        btfsc       setup,0     ;  -\-
            goto        glubina     ;    - 
;-----------------------------------------------------------------------------
;            
;              TTM(L,M) TTP(L,M)
;----------------------------------------------------------------------------- 
prov        btfsc      Flag,3      ;   3 
            goto       diapazon    ;  1          
            bsf        Flag,3      ;  0  3  
            bcf        Flag,2      ;  2      povtor
            goto       povtor      ;        - 
                                   ; -        32-750                

;--------------------------------------------------------------------------------
;     
;  set,1   1       
;--------------------------------------------------------------------------------
diapazon    btfsc       setup,0     ;  -\-
            goto        $+0Ah       ;   10  
            movf        Uup1L,W     ; ------------------------------------------------
            movwf       RegL        ;    Uup1   Reg
            movf        Uup1M,W     ;
            movwf       RegM        ;
            movf        TimerL,W    ;    Timer   Tim
            movwf       TimL        ;
            movf        TimerM,W    ;
            movwf       TimM        ; ------------------------------------------------
            goto        $+9         ;   9  

            movf        TimerL,W    ; ------------------------------------------------
            movwf       RegL        ;    Timer   Reg
            movf        TimerM,W    ;
            movwf       RegM        ;
            movf        Uup1L,W     ;    Uup1   Tim
            movwf       TimL        ;
            movf        Uup1M,W     ;
            movwf       TimM        ; -------------------------------------------------

            comf        RegL,F      ;      RegL  
            incf        RegL,F      ;   .
            btfsc       Status,Z    ;     .
            decf        RegM,F      ;   ,     RegM
                                    ;       RegM.
            comf        RegM,F      ;    ,     
                                    ;   RegM.
;==============================================================================================
;  .
;==============================================================================================
; RegL + TimL    .
;-------------------------------------------------
            movf        RegL,W      ;    RegL  TimL
            addwf       TimL,F      ;      TimL.
            btfss       Status,C    ;    -.
            goto        MINUS_2     ;    ,     MINUS_2.
            incf        TimM,F      ;   ,     TimM.
;-------------------------------------------------
; RegM + TimerM    .
;-------------------------------------------------
MINUS_2     movf        RegM,W      ;    RegM  TimM
            addwf       TimM,F      ;      TimM.
            btfsc       Status,C    ;    -.
            goto        zero1up     ;       238-238=0
;---------------------------------------------------------------------------------------------
;         .
;---------------------------------------------------------------------------------------------
            call        vkl1        ;        vkl1 ( 1 )
            goto        diapazon_1  ;     diapazon_1
;---------------------------------------------------------------------------------------------
zero1up     btfss       Status,Z    ; --------------------------------------------------- 
            goto        diapazon_1  ;       
            bcf         Status,Z    ;   vkl1 ( 1 )
            movf        TimL,W      ;
            btfss       Status,Z    ;
            goto        diapazon_1  ;      diapazon_1
            call        vkl1        ;  0   vkl1
;---------------------------------------------------------------------------------------------          
diapazon_1  btfsc       setup,0     ;  -\-
            goto        $+0Ah       ;   10  
            movf        TimerL,W    ; ------------------------------------------------
            movwf       RegL        ;    Timer   Reg
            movf        TimerM,W    ;
            movwf       RegM        ;
            movf        Udn1L,W     ;    Udn1   Tim
            movwf       TimL        ;
            movf        Udn1M,W     ;
            movwf       TimM        ; ------------------------------------------------
            goto        $+9         ;   9  

            movf        TimerL,W    ; ------------------------------------------------
            movwf       TimL        ;    Timer   Reg
            movf        TimerM,W    ;
            movwf       TimM        ;
            movf        Udn1L,W     ;    Uup1   Tim
            movwf       RegL        ;
            movf        Udn1M,W     ;
            movwf       RegM        ; ------------------------------------------------

            comf        RegL,F      ;      RegL  
            incf        RegL,F      ;   .
            btfsc       Status,Z    ;     .
            decf        RegM,F      ;   ,     RegM
                                    ;       RegM.
            comf        RegM,F      ;    ,     
                                    ;   RegM.
;==============================================================================================
;  .
;==============================================================================================
; RegL + TimL    .
;-------------------------------------------------
            movf        RegL,W      ;    RegL  TimL
            addwf       TimL,F      ;      TimL.
            btfss       Status,C    ;    -.
            goto        MINUS_3     ;    ,     MINUS_3.
            incf        TimM,F      ;   ,     TimM.
;-------------------------------------------------
; RegM + TimerM    .
;-------------------------------------------------
MINUS_3     movf        RegM,W      ;    RegM  TimM
            addwf       TimM,F      ;      TimM.
            btfsc       Status,C    ;    -.
            goto        zero1dn     ;       238-238=0 
;---------------------------------------------------------------------------------------------
;         .
;---------------------------------------------------------------------------------------------
            call        otkl1       ;        otkl1 ( 1 )
            goto        diapazon_2  ;     diapazon_2
;---------------------------------------------------------------------------------------------
zero1dn     btfss       Status,Z    ; --------------------------------------------------- 
            goto        diapazon_2  ;       
            bcf         Status,Z    ;   otkl1 ( 1 )
            movf        TimL,W      ;
            btfss       Status,Z    ;   Z
            goto        diapazon_2  ;      diapazon_2
            call        otkl1       ;  0   otkl1
;---------------------------------------------------------------------------------------------          
diapazon_2  btfsc       setup,0     ;  -\-
            goto        $+0Ah       ;   10  
            movf        Uup2L,W     ; ------------------------------------------------
            movwf       RegL        ;    Uup2   Reg
            movf        Uup2M,W     ;
            movwf       RegM        ;
            movf        TimerL,W    ;    Timer   Tim
            movwf       TimL        ;
            movf        TimerM,W    ;
            movwf       TimM        ; ------------------------------------------------
            goto        $+9         ;   9  
            
            movf        TimerL,W    ; ------------------------------------------------
            movwf       RegL        ;    Timer   Reg
            movf        TimerM,W    ;
            movwf       RegM        ;
            movf        Uup2L,W     ;    Uup2   Tim
            movwf       TimL        ;
            movf        Uup2M,W     ;
            movwf       TimM        ; ------------------------------------------------

            comf        RegL,F      ;      RegL  
            incf        RegL,F      ;   .
            btfsc       Status,Z    ;     .
            decf        RegM,F      ;   ,     RegM
                                    ;       RegM.
            comf        RegM,F      ;    ,     
                                    ;   RegM.
;==============================================================================================
;  .
;==============================================================================================
; RegL + TimL    .
;-------------------------------------------------
            movf        RegL,W      ;    RegL  TimL
            addwf       TimL,F      ;      TimL.
            btfss       Status,C    ;    -.
            goto        MINUS_4     ;    ,     MINUS_4.
            incf        TimM,F      ;   ,     TimM.
;-------------------------------------------------
; RegM + TimerM    .
;-------------------------------------------------
MINUS_4     movf        RegM,W      ;    RegM  TimM
            addwf       TimM,F      ;      TimM.
            btfsc       Status,C    ;    -.
            goto        zero2up
;---------------------------------------------------------------------------------------------
;         .
;---------------------------------------------------------------------------------------------
            call        vkl2        ;        vkl2 ( 2 )
            goto        diapazon_3  ;     diapazon_3 
;---------------------------------------------------------------------------------------------
zero2up     btfss       Status,Z    ; --------------------------------------------------- 
            goto        diapazon_3  ;       
            bcf         Status,Z    ;   vkl2 ( 2 ) 
            movf        TimL,W      ;
            btfss       Status,Z    ;   Z
            goto        diapazon_3  ;      diapazon_3
            call        vkl2        ;  0   vkl2
;---------------------------------------------------------------------------------------------          
diapazon_3  btfsc       setup,0     ;  -\-
            goto        $+0Ah       ;   10  
            movf        TimerL,W    ; ------------------------------------------------
            movwf       RegL        ;
            movf        TimerM,W    ;    Timer   Reg
            movwf       RegM        ;
            movf        Udn2L,W     ;    Udn2   Tim
            movwf       TimL        ;
            movf        Udn2M,W     ;
            movwf       TimM        ; ------------------------------------------------
            goto        $+9         ;   9  

            movf        TimerL,W    ; ------------------------------------------------
            movwf       TimL        ;
            movf        TimerM,W    ;    Timer   Tim
            movwf       TimM        ;
            movf        Udn2L,W     ;
            movwf       RegL        ;    Udn2   Reg
            movf        Udn2M,W     ;
            movwf       RegM        ; ------------------------------------------------

            comf        RegL,F      ;      RegL  
            incf        RegL,F      ;   .
            btfsc       Status,Z    ;     .
            decf        RegM,F      ;   ,     RegM
                                    ;       RegM.
            comf        RegM,F      ;    ,     
                                    ;   RegM.
;==============================================================================================
;  .
;==============================================================================================
; RegL + TimL    .
;-------------------------------------------------
            movf        RegL,W      ;    RegL  TimL
            addwf       TimL,F      ;      TimL.
   
            btfss       Status,C    ;    -.
            goto        MINUS_5     ;    ,     MINUS_5.
            incf        TimM,F      ;   ,     TimM.
;-------------------------------------------------
; RegM + TimerM    .
;-------------------------------------------------
MINUS_5     movf        RegM,W      ;    RegM  TimM
            addwf       TimM,F      ;      TimerM.
            btfsc       Status,C    ;    -.
            goto        zero2dn     ;       238-238=0 
;---------------------------------------------------------------------------------------------
;         .
;---------------------------------------------------------------------------------------------
            call        otkl2       ;        otkl2 ( 2 )
            goto        zxc         ;     zxc
;---------------------------------------------------------------------------------------------
zero2dn     btfss       Status,Z    ; ---------------------------------------------------
            goto        zxc         ;       
            bcf         Status,Z    ;   otkl2 ( 2 )
            movf        TimL,W      ;
            btfss       Status,Z    ;   Z
            goto        zxc         ;      zxc
            call        otkl2       ;  0   otkl2
;---------------------------------------------------------------------------------------------
;     Timer  TT   "+" "-"     Timer
;---------------------------------------------------------------------------------------------
zxc         movf        TimerL,W    ;   TimerL,      
            movwf       TTL         ; TTL, TTM         
            movf        TimerM,W    ;     TTL, TTM     
            movwf       TTM         ; TimerL,    

;====================================================================================================
;    STATUS  W   
;  .
;--------------------------------------------------------------------------------
EndInt      bsf	Flag1,0     ;   W .1
            bsf	Memory,0    ;  1  Memory
            movlw       .45         ;     
            movwf       Sensor      ;    
            bcf         PortB,4     ;     
	bcf	IntCon,7
            clrf        TMR1H       ;  TMR1L
            clrf        TMR1L       ;  TMR1
	movlw	.7
	movwf	T1CON
            movf        Stat_Temp,W ;    Stat_Temp
                                    ;   W.
            movwf       Status      ;    W
                                    ;   Status.
            swapf       W_Temp,F    ;      
                                    ;  W_Temp   
                                    ;    .
            swapf       W_Temp,W    ;      
            clrf        Tmr0        ;  W_Temp   
                                                                                                                                  
            retfie                  ;     
EndInt1     bsf         Flag,1      ;   1  1  
            goto        EndInt      ;   EndInt 
;*************************************************************************************
glubina     movf        TimerL,W    ; ----------------------------------------- 
            movwf       Temp1       ;   Timer 
            movf        TimerM,W    ;  Temp1  Temp2
            movwf       Temp2       ;
            movf        rezervuarL,W;   rezervuar 
            movwf       TimerL      ;  TimerL  TimerM
            movf        rezervuarM,W; 
            movwf       TimerM      ; -----------------------------------------
;***********************************************************************************************
;      .
;***********************************************************************************************
;       Temp1,M
;===============================================================================================
            comf       Temp1,F      ;      Temp1  
            incf       Temp1,F      ;   .
            btfsc      Status,Z     ;     .
            decf       Temp2,F      ;   ,     Temp2
                                    ;       Temp2.
            comf       Temp2,F      ;    ,     
                                    ;   Temp2.
;==============================================================================================
;  .
;==============================================================================================
; Temp1 + TimerL    .
;-------------------------------------------------
            movf       Temp1,W      ;    Temp1  TimerL
            addwf      TimerL,F     ;      TimerL.
            btfss      Status,C     ;    -.
            goto       MINUS_1ob    ;    ,     MINUS_1ob.
            incf       TimerM,F     ;   ,     TimerM.
;--------------------------------------------------------------------------------------
; Temp2 + TimerM    .
;      
;---------------------------------------------------------------------------------------------
MINUS_1ob   movf       Temp2,W      ;    Temp2  TimerM
            addwf      TimerM,F     ;      TimerM.
;-----------------------------------------------------------------------------
;            
;              TTM(L,M) TTP(L,M)
;----------------------------------------------------------------------------- 
            btfsc      Flag,2       ;   2
            goto       diapazon     ;  1          
            bsf        Flag,2       ;  0  2  
            bcf        Flag,3       ;  3      povtor
            goto       povtor       ;        - 
                                    ; -        32-750             
;-------------------------------------------------------------------------------------------------
;***********************************************************************************************
;       Index     
;  .
;-----------------------------------------------------------------------------------------------
NEW1        clrf        Index       ;   0      Index.
;-----------------------------------------------------------------------------------------------
CYCLER	movlw       high RTY    ;  ( W),  PCH ( PCLATH),  
            movwf       PCLATH      ;      ,  
RTY	movlw       LED0        ;    W   LED0.
            addwf       Index,W     ;    LED0   ,
                                    ;       
                                    ;  Index, c     W.                                   
            movwf       FSR         ;    W   FSR.
            movf        Indf,W      ;     , 
                                    ;   FSR,   W.
            call        TABLE1      ;   (   
                                    ;  )   TABLE.

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;         .
;-----------------------------------------------------------------------------------------------
            movwf       Temp        ; *******************************************************
            movf        Index,W     ;  
            addwf       PC,f        ;  
            goto        $+3         ;  
            goto        $+5         ;      
            goto        $+7         ;
            movf        Temp,W      ;
            movwf       d8          ;       
            goto        opar        ;
            movf        Temp,W      ;
            movwf       d7          ;          
            goto        opar        ;
            movf        Temp,W      ;
            movwf       d6          ;
            goto        opar        ; *********************************************************

;-----------------------------------------------------------------------------------------------
;   1       Index  
;      ( )  .08.
;-----------------------------------------------------------------------------------------------
opar        incf        Index,F     ;   1   Index  
                                    ;    .
            movlw       .03         ;    W  .03.
            bcf         Status,Z    ;     Z.
            subwf       Index,W     ;     Index  
                                    ; W      W.
            btfss       Status,Z    ;       ? 
            goto        CYCLER      ;   =0 (  Index -    3), 
                                    ;       
                                    ; 7-  (   
                                    ;  ,  ,   CYCLER).
                                    ;  =0 (  Index -   3),  
                                    ;  .
;-----------------------------------------------------------------------------------------------
;         ,   - 
;   8 7-   (  8-   ).
;-----------------------------------------------------------------------------------------------
            clrf        Index       ;   0   Index.
            return
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TABLE1      bsf         PCLATH,1
            addwf       PC,F        ;    PC 
                                    ;     W.
            retlw       0EEh        ; ..FEDCBA = 0               
            retlw       060h        ; .....CB. = 1               
            retlw       02Fh        ; .G.ED.BA = 2               
            retlw       06Dh        ; .G..DCBA = 3               
            retlw       0E1h        ; .GF..CB. = 4       
            retlw       0CDh        ; .GF.DC.A = 5      
            retlw       0CFh        ; .GFEDC.A = 6        
            retlw       068h        ; .....CBA = 7                                     
            retlw       0EFh        ; .GFEDCBA = 8                                     
            retlw       0EDh        ; .GF.DCBA = 9
;***************************************************************************************************
;==================================================================================================
START       bsf         Status,5    ; "" ""    
            bcf         Status,6    ; 1- .
            clrf        VRCON       ;    .
            bcf         Status,5    ;  0-  (,   
            movlw       .07         ;  .
            movwf       CMCON       ; --------"--------
            clrf        RCSTA       ;  USART.
            clrf        T1CON       ; ----"----  TMR1.
            clrf        T2CON       ; ----"----  TMR2.
            clrf        CCP1CON     ; ----"------CCP1CON
	goto	METKA_1
;-----------------------------------------------------------------------------------------------------
;    ROM 
;-----------------------------------------------------------------------------------------------------

asdf        bsf         Status,5    ;   0 
            movwf       EEAdr       ;  00h,   W,   EEAdr
            bsf         EECon1,0    ;  
            movf        EEData,W    ;    EEPROM,   00h,   W
            bcf         Status,5    ;   0 
	return
;-----------------------------------------------------------------------
METKA_1     movlw       0           ;
            call        asdf        ; 
            movwf       Udn1M       ;   Udn1M
;------------------------------------------------------------------------
METKA_2     movlw       1           ;
            call        asdf        ; Udn1L
            movwf       Uup1L       ;   Uup1L
;------------------------------------------------------------------------
METKA_3     movlw       2           ;
            call        asdf        ; Udn1L  
            movwf       Udn1L       ;   
;------------------------------------------------------------------------
METKA_4     movlw       3           ;
            call        asdf        ; Udn2M  
            movwf       Udn2M       ;  
;------------------------------------------------------------------------
METKA_5     movlw       4           ;
            call        asdf        ; Udn1L 
            movwf       Uup2L       ;   Uup1L
 ;-----------------------------------------------------------------------
METKA_6     movlw       5           ;
            call        asdf        ; 
            movwf       Udn2L       ;   Udn1M
;------------------------------------------------------------------------
METKA_7     movlw       6           ;
            call        asdf        ; 
            movwf       setup       ;   Udn1M 
;------------------------------------------------------------------------
METKA_8     movlw       7           ;
            call        asdf        ; 
            movwf       Uup1M       ;   Udn1M 
;-----------------------------------------------------------------------
METKA_9     movlw       8           ;
            call        asdf        ; 
            movwf       Uup2M       ;   Udn1M 
;-----------------------------------------------------------------------
METKA_10    movlw       9           ;
            call        asdf        ; 
            movwf       rezervuarL  ;   Udn1M
;-----------------------------------------------------------------------
METKA_11    movlw       .10         ;
            call        asdf        ; 
            movwf       rezervuarM  ;   Udn1M
;----------------------------------------------------------------------------------------------------------
            clrwdt                  ;  wdt
            bsf         Status,5    ;   1.
            bcf         Status,6    ;   1
            clrf        TrisA       ; (00000000)      
            clrf        TrisB       ; (00000000)     
            bcf         Status,5    ;   0.
            clrf        PortA       ;      
            clrf        PortB       ;      
;-----------------------------------------------------------------------------------------------
;                
;-----------------------------------------------------------------------------------------------
            movlw       0x0F        ; ----------------------------------------------------      
            call        lcd_cw      ;   
            movlw       01h         ;
            call        lcd_dw      ; ****************************************************
            clrf        d0          ;
            clrf        d1          ; 
            clrf        d7          ;
            clrf        d8          ;
            clrf        d9          ;
            movlw       0CDh        ;
            movwf       d2          ;   " StArt "
            movlw       87h         ;
            movwf       d3          ;
            movwf       d6          ;
            movlw       0EBh        ;
            movwf       d4          ;
            movlw       03h         ;
            movwf       d5          ; ****************************************************
            call        indic       ;   " StArt "  
            movlw       .93         ; 93--------------------------------------------------
            movwf       SecL        ;
            movlw       .38         ; 38      
            movwf       SecM        ;
            movlw       .11         ; 11            " StArt "
            movwf       SecH        ; --------------------------------------------------
            call        Vremy       ;     1
            clrf        d1          ; ***************************************************
            clrf        d2          ; 
            clrf        d3          ;    d1-d6
            clrf        d4          ;
            clrf        d5          ;
            clrf        d6          ;---------------------------------------------------
            call        indic       ;   "0"  
            movlw       .45         ;     .   
            movwf       Sensor      ; *********************************************
            movlw       .5          ;       OPRO_obhod
            movwf       ABD         ; *********************************************
            movlw       .6          ;      "no SEnSor"
            movwf       Sensor1     ; *********************************************
            movlw       .10         ;     
                                    ;        
            movwf       ABC         ;      
povtor      bcf         Flag,1      ; ----------------------------------------------------
            bcf         Flag,4      ;
            bcf         Flag,5      ;   3  
            bcf         Flag,6      ;
            bcf         Flag,7      ;
            clrf        nakopitL    ;
            clrf        nakopitM    ; -----------------------------------------------------
	clrf	Flag1
            clrwdt                  ;  wdt

 
;***********************************************************************************************
;******************************    ****************************************
;***********************************************************************************************
;-----------------------------------------------------------------------------------------------  
;                        
;-----------------------------------------------------------------------------------------------
OPROS       bsf         Status,5    ;   1.
            movlw       .2          ; RB1   
            movwf       TrisB       ;   
            bcf         Status,5    ;   0.
            btfss       PortB,1     ;    1(RB1)
            goto        OPROS_K     ;      OPROS_K
START11     movlw       .5          ;      5 
            movwf       ABD         ;  ABD (      OPRO_obhod)
START12     clrf        IntCon      ;  
            bsf         Status,5    ;   1.
            movlw       .175        ; (10101111) wdt128,  TMR0,  
            movwf       OptionR     ;  TMR0, . .  INT,. . .  
            movlw       b'01000001' ; RB0,6   ,
On_TMRO     movwf       TrisB       ;  -  .
            bcf         Status,5    ;   0-  (  0 5- )
            clrwdt                  ;  wdt
;---------------------------------------------------------------------------------------------
;     .
;---------------------------------------------------------------------------------------------
            movlw       .4          ;    SecM
            movwf       SecM        ;  .16 
;---------------------------------------------------------------------------------------------
            clrf        TimerM      ;   0   TimerM.
            clrf        TimerH      ;   0   TimerH.
            clrf        TMR1L       ;  TMR1L
            clrf        TMR1H       ;  TMR1H   TMR1  
            movlw       .1          ; (00001101)TMR1-, . . Fosc/4,
            movwf       T1CON       ;  (  TMR1)
;---------------------------------------------------------------------------------------------
;      PortB,3 .
;---------------------------------------------------------------------------------------------
PERIUD_1    bcf         PortB,3     ;    .
            nop                     ;     
            movlw       .3          ;    Sec 
            movwf       SecL        ;  .3
PAUSE_1     decfsz      SecL,F      ;   
            goto        PAUSE_1     ;  .
;--------------------------------------------------------------------------------------------
;      PortB,3.
;--------------------------------------------------------------------------------------------                      
            bsf         PortB,3     ;    .
            nop                     ;     
            nop                     ;     
            movlw       .2          ;    Sec 
            movwf       SecL        ;  .2
PAUSE_2     decfsz      SecL,F      ;  
            goto        PAUSE_2     ;  .
;--------------------------------------------------------------------------------------------
;                        
;--------------------------------------------------------------------------------------------  
            decfsz      SecM,F      ;   
            goto        PERIUD_1    ;   PERIUD_1 
;--------------------------------------------------------------------------------------------
;      
;--------------------------------------------------------------------------------------------
            movlw       .246        ; 146-------------------------------------------------------
            movwf       SecL        ;
            movlw       .3          ;         
            movwf       SecM        ;                   40 
            movlw       .1          ;
            movwf       SecH        ; -------------------------------------------------------
            call        Vremy       ;   Vremy ( )
;--------------------------------------------------------------------------------------------
;     
;--------------------------------------------------------------------------------------------
            movlw       .208        ; (11010000) .INT , .   
            movwf       IntCon      ; . .,  
;--------------------------------------------------------------------------------------------
            movlw       .84         ; 34 -------------------------------------------------------
            movwf       SecL        ;
            movlw       .55         ; 25     40-750
            movwf       SecM        ; 
            movlw       .1          ;
            movwf       SecH        ; -------------------------------------------------------
            call        Vremy       ;   Vremy ( )
;--------------------------------------------------------------------------------------------
;     
;--------------------------------------------------------------------------------------------
            nop		;
            clrf        IntCon      ;   
	btfss	Flag1,0	;       
	goto	lllp	;   
	bcf	T1CON,0	;  ,   TMR1 (   
            movf        TMR1L,W     ;    TMR1L  W
	bsf	Status,0	;    
	sublw	.15	; 15 -  W
	btfss	Status,0	;   
	goto	limit 	;     limit
lllp        movf        Memory,W    ;    Memory  W 
            bcf         Status,2    ;   Z
            sublw       .1          ; 1-Memory=( .     .=0)
            btfss       Status,2    ;       ?
            goto        NO_SENSOR   ;       NO_SENSOR
            movlw       .6          ; ,  6  Sensor1(     
            movwf       Sensor1     ;     NO_SENSOR)
            btfss       Flag,1      ;   1 
            goto        BBin2_10    ;  =0  BBin2_10
            movf        TTL,W       ; -----------------------------------------------------
            movwf       TimerL      ;   TTL,TT  Timer
            movf        TTM,W       ;
            movwf       TimerM      ; ----------------------------------------------------
BBin2_10    call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            clrf        d4          ;  ""
Pamyat      call        screen      ;    
Zadergka    movlw       .224        ;  -----------------------------------------------------
            movwf       SecL        ; 
            movlw       .76         ; 89           
            movwf       SecM        ;         (   300)
            movlw       .2          ; 
            movwf       SecH        ;--------------------------------------------------------
            call        Vremy       ;   Vremy ( )
            clrf        Memory      ;  Memory
	bcf	Flag1,0	;     
;----------------------------------------------------------------------------------------------
;    
;----------------------------------------------------------------------------------------------
            bsf         Status,5    ;   1.
            movlw       .4          ; RB2   
            movwf       TrisB       ;   
            bcf         Status,5    ;   0.
            btfss       PortB,2     ;    2(RB2)
            goto        sbros       ;      sbros 
            movlw       .10         ;  10  ABC(    
            movwf       ABC         ;        
                                    ;     
            goto        OPROS       ;            
;-------------------------------------------------------------------------------------------
;      
;     PortB,4    1  2 (PortB,5 PortB,7),  
;  "briv"
;------------------------------------------------------------------------------------------- 
limit	bsf	PortB,4	;   ""
	bcf	PortB,5	;  1 
	bcf	PortB,7	;  2 
	clrf	d0	; -----------------------------
	clrf	d1	;
	clrf	d7	;  d0,1,7-9
	clrf	d8	;
	clrf	d9	; -----------------------------
	movlw	.71	;
	movwf	d2	;
	movlw	.199	;
	movwf	d3	;      "  obriu   "
	movlw	.3	;
	movwf	d4	;
	movlw	.64	;
	movwf	d5	;
	movlw	.70	;
	movwf	d6	;
	call	indic	;
            movlw       .224        ;  -----------------------------------------------------
            movwf       SecL        ; 
            movlw       .76         ;            
            movwf       SecM        ;         (   300)
            movlw       .2          ; 
            movwf       SecH        ;--------------------------------------------------------
            call        Vremy       ;   Vremy ( )
            bsf         Status,5    ;   1.
            movlw       .4          ; RB2   
            movwf       TrisB       ;   
            bcf         Status,5    ;   0.
            btfsc       PortB,2     ;    2(RB2)
            goto        $-1         ;      sbros 
	call	Vremya	; 
            btfsc       PortB,2     ;    2(RB2)
            goto        $-4         ;      sbros 
	goto	START	;    
;-------------------------------------------------------------------------------------------
screen      clrf        d0          ;  ""
            clrf        d5          ;  ""
            clrf        d9          ;  ""
;-------------------------------------------------------------------------------------------
;      
;------------------------------------------------------------------------------------------
indic       movlw       0           ;  0  W
            call        lcd_cw      ;  
            movf        d0,W        ; ----------------------------------------------------
            call        lcd_dw      ; 
            movf        d1,W        ;
            call        lcd_dw      ; 
            movf        d2,W        ;
            call        lcd_dw      ;
            movf        d3,W        ;              
            call        lcd_dw      ;
            movf        d4,W        ;
            call        lcd_dw      ;
            movf        d5,W        ;
            call        lcd_dw      ;             
            movf        d6,W        ;
            call        lcd_dw      ;
            movf        d7,W        ;
            call        lcd_dw      ;
            movf        d8,W        ;
            call        lcd_dw      ;
            movf        d9,W        ;
            call        lcd_dw      ; -----------------------------------------------------
            return                  ;   
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    4-    8-  .
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   .
;===============================================================================================
Bin2_10     bcf        Status,C     ;   -.
            movlw      .16          ;    Count   ,
            movwf      Count        ;     
                                    ;  TimerL/TimerM (8*2=16).

            clrf       LED0         ;   0   LED0.
            clrf       LED1         ; -------"------ LED1.
            clrf       LED2         ; -------"------ LED2.
;===============================================================================================
;   .
;===============================================================================================         
Loop16      rlf        TimerL,F     ;    4-  ,
            rlf        TimerM,F     ;     TimerL/TimerM/TimerH/TimerHH,
            rlf        LED0,F       ;    4-  ,
            rlf        LED1,F       ;     LED0/LED1/LED2/LED3,
            rlf        LED2,F       ;        STATUS.
            decfsz     Count,F      ;  (-1)   Count  
                                    ;    .
            goto       adjDEC       ;   =0,     adjDEC
                                    ;    =0,    .
;===============================================================================================
;     LED0...3 (
; )     LED0...7.
;===============================================================================================
            swapf      LED1,W       ;    LED1
            andlw      0Fh          ;    LED3.
            movwf      LED2         ; --------------------------------

            movfw      LED1         ;    LED1
            andlw      0Fh          ;    LED2.
            movwf      LED2         ; --------------------------------

            swapf      LED0,W       ;    LED0
            andlw      0Fh          ;    LED1.
            movwf      LED1         ; --------------------------------

            movfw      LED0         ;    LED0
            andlw      0Fh          ;    LED0.
            movwf      LED0         ; --------------------------------
;--------------------------------------------------------------------
;  .     LED0...7 
; -     .   = 0.
;--------------------------------------------------------------------
           return                   ;      
;===============================================================================================
;    FSR   LED0...3    
;     adjBCD.
;     LED -    .                      
;===============================================================================================
adjDEC      movlw      LED0         ;    FSR,   W,   LED0
            movwf      FSR          ;      adjBCD
            call       adjBCD       ; (     ).
;--->      adjBCD.                                  
            movlw      LED1         ; -----------------------------
            movwf      FSR          ;      LED1.
            call       adjBCD       ; -----------------------------
;--->      adjBCD.
            goto       Loop16
;===============================================================================================
;       -:
;   LED0...3   03h,30h    3-  7- .
;===============================================================================================
adjBCD      movlw      3            ;    LED (LED0...3)   03h,  
            addwf      0,W          ; c   ,   W,
            movwf      Mem          ;   Mem.
  
            btfsc      Mem,3        ;   3-   Mem.
            movwf      0            ;    3 =1,    Mem 
                                    ;    LED.

            movlw      30           ;   3 =0,    LED 
            addwf      0,W          ;   30h,     ,  
            movwf      Mem          ;   W,   Mem.
 
            btfsc      Mem,7        ;   7-   Mem.
            movwf      0            ;   7 =1,    Mem 
                                    ;    LED.

            retlw      0            ;   7 =0,   W   
                                    ;      adjDEC.

;--------------------------------------------------------------------------------
;    
;--------------------------------------------------------------------------------
Vremya      movlw       .205        ;   .205   W
            movwf       SecL        ;    W   SecL
            movlw       .195        ;   .195   W
            movwf       SecM        ;    W   SecM
            movlw       .1          ;   .1   W
            movwf       SecH        ;    W   SecH
Vremy       clrf        Tmr0        ;   Tmr0
            decfsz      SecL,F      ;    SecL  1
            goto        $-1         ; 
            decfsz      SecM,F      ;    SecM  1
            goto        $-3         ; 
            decfsz      SecH,F      ;    SecH  1
            goto        $-5         ; 
            clrwdt
            return                  ;   
;--------------------------------------------------------------------------------
;     EEPROM
;--------------------------------------------------------------------------------
zapis       movwf       EEData      ;  ,   W,     01h.
            bsf         EECon1,2    ;  .
            bcf         Status,5    ;   0.
            bcf         PIR1,7      ;     eeprom
            bsf         Status,5    ;   1.
            movlw       055h        ; 
            movwf       EECon2      ; 
            movlw       0AAh        ;  .
            movwf       EECon2      ; ----"----
            bsf         EECon1,1    ; ----"----
            bcf         Status,5    ;   0.
wr1         btfss       PIR1,7      ;     eeprom
            goto        wr1         ;   wr1
            bsf         Status,5    ;   1.
            bcf         EECon1,2    ;  .
            bcf         Status,5    ;   0.
            return                  ;   
;---------------------------------------------------------------
;         
;---------------------------------------------------------------
lcd_dw      movwf       Temp        ;        
            movf        Temp,W      ;      (4 ),  
            andlw       0x0F        ;  4   RA0-3 
            movwf       PortA       ; Data
            bsf         PortA,6     ; (AO)   
            bsf         PortA,7     ; (WR1)
            bcf         PortA,7     ;-----------------------------------------------------
            swapf       Temp,W      ;      RA0-3
            andlw       0x0F        ;
            movwf       PortA       ;-----------------------------------------------------
            bsf         PortA,6     ;    
            bsf         PortA,7     ;
            bcf         PortA,7     ;-----------------------------------------------------
            return
;---------------------------------------------------------------
;        
;---------------------------------------------------------------
lcd_cw      movwf       Temp        ;        
            movf        Temp,W      ;      (4 ),  
            andlw       0x0F        ;  4   RA0-3
            movwf       PortA       ; Data 
            bcf         PortA,6     ; (A0)   
            bsf         PortA,7     ; (WR1)
            bcf         PortA,7     ;-----------------------------------------------------
            swapf       Temp,W      ;      RA0-3
            andlw       0x0F        ;
            movwf       PortA       ;-----------------------------------------------------
            bcf         PortA,6     ; 
            bsf         PortA,7     ;   
            bcf         PortA,7     ;
            bsf         PortA,6     ;-----------------------------------------------------
            return
;--------------------------------------------------------------------------------
;      PortB,5
;--------------------------------------------------------------------------------
vkl1        btfsc	setup,1     ;     
	goto	zzz0	;  
zzz1	bsf         PortB,5     ;   1    B  5
            movlw       60h         ;     d1 a 1
            movwf       d1          ; ----------------------------------------
            return   

;--------------------------------------------------------------------------------
;      PortB,5
;--------------------------------------------------------------------------------
otkl1	btfsc	setup,1	;     
	goto	zzz1	;  
zzz0	bcf         PortB,5     ;   0    B  5
            clrf        d1          ; ----------------------------------------
            return 
;--------------------------------------------------------------------------------
;    2   PortB,7
;--------------------------------------------------------------------------------
vkl2        btfsc	setup,1	;     
	goto	zzz2	;  	
zzz3	bsf         PortB,7     ; ***************************************
            clrf        d2          ;       d2 
            movlw       2Fh         ;  2   (d3)
            movwf       d3          ; ***************************************
            return   
;--------------------------------------------------------------------------------
;    2   PortB,7
;--------------------------------------------------------------------------------
otkl2       btfsc	setup,1	;     
	goto	zzz3	;  
zzz2	bcf         PortB,7     ;   0    B  7
            clrf        d2          ;      
            clrf        d3          ;  d2-d3
            return
;--------------------------------------------------------------------------------
;       "no SEnSor'
;--------------------------------------------------------------------------------
NO_SENSOR   movf        d1,W        ; ***************************************
            movwf       temd1       ;
            movf        d2,W        ;
            movwf       temd2       ;
            movf        d3,W        ;   d1-d8   
            movwf       temd3       ;              temd1-temd8
            movf        d4,W        ;         
            movwf       temd4       ;    " no SEnSor "
            movf        d5,W        ;   d1-d8  
            movwf       temd5       ;
            movf        d6,W        ;
            movwf       temd6       ;
            movf        d7,W        ;
            movwf       temd7       ;
            movf        d8,W        ;
            movwf       temd8       ; ****************************************
            bcf         Status,Z    ;   "no SEnSor"   
            decf        Sensor1,F   ;    Sensor1  
            btfss       Status,Z    ;    Pamyat
            goto        Pamyat      ;
            movlw       43h         ; ****************************************
            movwf       d1          ;
            movwf       d6          ; 
            movlw       47h         ;      
            movwf       d2          ;
            movwf       d8          ;       " no SEnSor "
            movlw       .0          ;
            movwf       d3          ;
            movlw       0CDh        ;
            movwf       d4          ;
            movwf       d7          ;
            movlw       8Fh         ;
            movwf       d5          ;
            movlw       03h         ;
            movwf       d9          ;*****************************************
            decfsz      Sensor,F    ;   (  )
            goto        $+2         ;    Sensor1,  
            bsf         PortB,4     ;    indic   
            call        indic       ;      d1-d8
obh_svetdio movf        temd1,W     ;*******************************************
            movwf       d1          ;
            movf        temd2,W     ; 
            movwf       d2          ;   d1-d8  
            movf        temd3,W     ;         
            movwf       d3          ;           " no SEnSor "
            movf        temd6,W     ;
            movwf       d6          ;
            movf        temd4,W     ; 
            movwf       d4          ;
            movf        temd5,W     ;
            movwf       d5          ;
            movf        temd7,W     ;
            movwf       d7          ;
            movf        temd8,W     ;
            movwf       d8          ;********************************************
            movlw       .6          ;  6-   Sensor1 ( 
            movwf       Sensor1     ;     " no SEnSor "
            goto        Zadergka    ;
;--------------------------------------------------------------------------------
;        " START "
;---------------------------------------------------------------------------------
sbros       movlw       .221        ; ***************************************
            movwf       SecL        ; 
            movlw       .130        ;    
            movwf       SecM        ;
            movlw       .1          ;     ""
            movwf       SecH        ; 
            call        Vremy       ; *****************************************
            btfss       PortB,2     ;      
            decfsz      ABC,F       ;    5- 
            goto        OPROS       ;   "  "
            goto        START
;*********************************************************************************
;********************    **********************************
;*********************************************************************************
OPROS_K     swapf       d1,W        ; --------------------------------------------
            movwf       TempD1      ;
            swapf       d3,W        ;   d1,3  
            movwf       TempD3      ;             TempD1,3
			; ------------------------------------------
            movlw       .85         ;   W .85
            movwf       SecL        ;    W   OprL
            movlw       .138        ;   W .138
            movwf       SecM        ;    W   OprM
            movlw       .3          ;   W .3
            movwf       SecH        ;    W   OprH
            call        Vremy       ;    Vremya    
            clrwdt                  ;  wdt
            movf        PortB,W     ;      W
            andlw       .2          ;    RB1
            movwf       EEE         ; C    
            incf        EEE,F       ;     
            decf        EEE,F       ;     
            btfss       Status,Z    ;    Z
            goto        START11     ;      START11
            decfsz      ABD,F       ;     ABD   
            goto        START12     ;   0   START12
;--------------------------------------------------------------------------------
            movlw       .1          ; ---------------------------------------------
            movwf       d1          ;      
            movwf       d2          ;
            movwf       d3          ;
            movwf       d4          ;  0      "---------"
            movwf       d5          ;
            movwf       d6          ;
            movwf       d7          ;
            movwf       d8          ;
            clrf        d0          ;
            clrf        d9          ; --------------------------------------------
            call        indic       ;    
            movlw       .93         ; --------------------------------------------
            movwf       SecL        ;          
            movlw       .38         ;     
            movwf       SecM        ;           OPRO_obhod
            movlw       .11         ; 
            movwf       SecH        ;
            call        Vremy       ; --------------------------------------------
            clrf        d1          ;
            clrf        d2          ;
            clrf        d3          ;   d1-d4
            clrf        d4          ; 
            clrwdt                  ;  wdt
;--------------------------------------------------------------------------------------------
kol_imp     bsf         Status,5    ;   1.
            clrf        PIE1	;  PIE1
            movlw       .237        ; 227   
            movwf       PR2	;
            movlw       .128        ; (10000000) 
            movwf       OptionR     ; . . . 
            movlw       .71         ; RB0-2,6   ,
            movwf       TrisB       ;  -  . 
            bcf         Status,5    ;   0-  (  0 5- )
            movlw       .64	;
            movwf       IntCon	;
;---------------------------------------------------------------------------------------------
;     .
;---------------------------------------------------------------------------------------------
            movlw       .4          ;    SecM
            movwf       SecM        ;  .16 
;---------------------------------------------------------------------------------------------
;      PortB,3 .
;---------------------------------------------------------------------------------------------
            bcf         PortB,3     ;    .
            nop                     ;     
            movlw       .3          ;    Sec 
            movwf       SecL        ;  .3
	decfsz      SecL,F      ;   
            goto        $-1         ;  .
;--------------------------------------------------------------------------------------------
;      PortB,3.
;--------------------------------------------------------------------------------------------                      
            bsf         PortB,3     ;    .
            nop                     ;     
            nop                     ;     
            movlw       .2          ;    Sec 
            movwf       SecL        ;  .2
            decfsz      SecL,F      ;  
            goto        $-1         ;  .
;--------------------------------------------------------------------------------------------
;                        
;--------------------------------------------------------------------------------------------  
            decfsz      SecM,F      ;   
            goto        $-.14       ;   PERIUD_1 
;--------------------------------------------------------------------------------------------
;      
;--------------------------------------------------------------------------------------------
            movlw       .246        ; 146-------------------------------------------------------
            movwf       SecL        ;
            movlw       .3          ;         
            movwf       SecM        ;                   40 
            movlw       .1          ;
            movwf       SecH        ; -------------------------------------------------------
            call        Vremy       ;   Vremy1 ( )
;--------------------------------------------------------------------------------------------
            movlw       .86         ; (1<<TMR2ON)
            movwf       T2CON	;  TMR2
;--------------------------------------------------------------------------------------------
            clrf        TMR2	;  TMR2
	clrf	TMR1H	;  TMR1H
	clrf	TMR1L	;  TMR1L
	clrf	TimerL	;  TimerL
	clrf	TimerM	;  TimerM
	movlw	.7          ; 7  W 
	movwf	T1CON 	;  TMR1,  
            clrwdt		;
	btfss	PIR1,1	;      TMR2
 	goto	$-2	;
	movf	TMR1L,W	;  TMR1L  TimerL
	movwf	TimerL	;
	movf	TMR1H,W	;  TMR1  Timer
	movwf	TimerM	; 
	bcf	PIR1,1	;      TMR2
	clrf	T1CON	;   TMR1
	clrf	T2CON	;   TMR2
	call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
	movlw	.96	; --------------------------------------------
	movwf	d1	;
	movlw	.67	;  " Im "
	movwf	d2	;	
	movlw	.65	;
	movwf	d3	; --------------------------------------------
            call        screen      ;    
	movlw       .224        ;  -----------------------------------------------------
            movwf       SecL        ; 
            movlw       .76         ;            
            movwf       SecM        ;         (   300)
            movlw       .2          ; 
            movwf       SecH        ;--------------------------------------------------------
            call        Vremy       ;   Vremy ( )
	btfsc	PortB,2 	;    "" 2
	goto	kol	;    
            call        Vremya      ;    Vremya  
	btfsc	PortB,2	;    "" 2
	goto	kol	;   
 	goto	yyyy0	;     
kol	btfsc	PortB,1	;    "" 1
	goto	kol_imp	;   	
	call	Vremya	;    Vremya  
	btfsc	PortB,1	;    "" 1
	goto	kol_imp	;   kol_imp
;*********************************************************************************
;      -\-
;*********************************************************************************
OPRO_obhod  bsf         Status,5    ;  1 
            movlw       .6          ;  RB1,RB2  
            movwf       TrisB       ;   
            bcf         Status,5    ;  0 
	movlw       .50         ;   50   Niz -
            movwf       Niz         ;    8
            movlw       .205        ; -----------------------------------------------------
            movwf       d1          ;
            movlw       .143        ;
            movwf       d2          ;
            movlw       .135        ;   SEt
            movwf       d3          ;
            clrf        d4          ; -----------------------------------------------------
            clrf        d6          ;  d6
            clrf        d7          ;  d7
            btfss       setup,0     ;   0
            goto        aaa3        ;  0   aaa3
            movlw       60h         ;  1   .96  W
aaa4        movwf       d8          ;     W,   d8.
            call        screen      ;    
            movlw       .93         ; --------------------------------------------
            movwf       SecL        ;          
            movlw       .38         ;     
            movwf       SecM        ;           OPRO_obhod
            movlw       .11         ; 
            movwf       SecH        ;
            call        Vremy       ; --------------------------------------------
KLAVA_obhod btfss       PortB,2     ;    2
            goto        obhod_plus  ;  .   obhod_plus
            btfss       PortB,1     ;   .   1
            goto        obhod_minus ;  .   obhod_minus
            call        Vremya      ;    Vremya
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_obhod ;    KLAVA_obhod
            bcf         IntCon,7    ;   .
            bsf         Status,5    ;   1.
            movlw       6           ; ,   W,  06h.
            movwf       EEAdr       ;   06h,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        setup,W     ;  ,   setup,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
            btfss       setup,0     ;    0   setup
            goto        OPRO_NIZ1   ;  0   OPRO_NIZ1
            goto        OPRO_REZERV ;  1   OPRO_REZERV
;--------------------------------------------------------------------------------------------
aaa3        movlw       0EEh        ;   .238  W 
            goto        aaa4        ;   aaa4

;--------------------------------------------------------------------------------------------
;          EEPROM  / - 
;--------------------------------------------------------------------------------------------
obhod_minus call        Vremya      ;    Vremya       
            bcf         setup,0     ;    0  0 (  -)
            movlw       0EEh        ;   .238  W 
            movwf       d8          ;     W,   d8.
            call        screen      ;    
            goto        KLAVA_obhod ;    KLAVA_obhod
;--------------------------------------------------------------------------------------------
;          EEPROM  / - 
;--------------------------------------------------------------------------------------------
obhod_plus  call        Vremya      ;    Vremya       
            bsf         setup,0     ;    0  1 (  -) 
            movlw       60h         ;   .96  W 
            movwf       d8          ;     W,   d8.
            call        screen      ;    
            goto        KLAVA_obhod ;    KLAVA_obhod
;*********************************************************************************
;     (-) 
;*********************************************************************************
OPRO_REZERV movlw       .80         ;   80   Niz -
            movwf       Niz         ;    10
            movlw       .134        ; -----------------------------------------------------
            movwf       d1          ;
            movlw       .143        ;   LEU
            movwf       d2          ;
            movlw       .230        ;
            movwf       d3          ; -----------------------------------------------------
            movf        rezervuarL,W;    W   rezervuarL
            movwf       TimerL      ;    W   TimerL
            movf        rezervuarM,W;    W   rezervuarM
            movwf       TimerM      ;    W   TimerM
            call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;     
KLAVA_rezer btfss       PortB,2     ;    2 
            goto        rezerv_plus ;  .   rezerv_plus 
            btfss       PortB,1     ;   .   1
            goto        rezerv_min  ;  .   rezerv_min 
            call        Vremya      ;    Vremya 
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_rezer ;    KLAVA_rezer
            bcf         IntCon,7    ;  1   .
            bsf         Status,5    ;   1.
            movlw       .9          ; ,   W,  9.
            movwf       EEAdr       ;   .9,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        rezervuarL,W;  ,   rezervuarL,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
            bsf         Status,5    ;   1.
            movlw       .10         ; ,   W,  .10
            movwf       EEAdr       ;   .10,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        rezervuarM,W;  ,   rezervuarM,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
            goto        OPRO_NIZ1   ;    OPRO_VER 
;--------------------------------------------------------------------------------------------  
;            EEPROM   
;--------------------------------------------------------------------------------------------
rezerv_min  call        Vremya      ;    Vremya    
            movlw       .1          ;  1  W
            bsf         Status,C    ;     1
            subwf       rezervuarL,F;   1  rezervuarL      .
            btfss       Status,C    ;   
            goto        aaa5        ;  0   aaa5
aaa8        movf        rezervuarL,W;    W   rezervuarL
            movwf       TimerL      ;    W   TimerL
            movf        rezervuarM,W;    W   rezervuarM
            movwf       TimerM      ;    W   TimerM
            goto        aaa6        ;   aaa6
aaa5        decf        rezervuarM,F;     rezervuarM
            btfsc       rezervuarM,7;    7
            goto        aaa7        ;  1  aaa7
            goto        aaa8        ;   aaa8
aaa6        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_rezer ;    KLAVA_rezer
aaa7        movlw       .2          ; -------------------------------------------------------  
            movwf       rezervuarM  ;   767    rezervuarM
            movlw       .255        ;
            movwf       rezervuarL  ; -------------------------------------------------------  
            goto        aaa8        ;   aaa8
;--------------------------------------------------------------------------------------------  
;                           EEPROM   
;--------------------------------------------------------------------------------------------
rezerv_plus call        Vremya      ;    Vremya    
            bcf         Status,Z    ;   Z 
            incf        rezervuarL,F;   1  rezervuarL      .
            btfsc       Status,Z    ;    Z
            goto        bbb1        ;  0  bbb1
bbb3        movf        rezervuarL,W;    W   rezervuarL
            movwf       TimerL      ;    W   TimerL
            movf        rezervuarM,W;    W   rezervuarM
            movwf       TimerM      ;    W   TimerM
            goto        bbb2        ;   bbb2
bbb1        incf        rezervuarM,F;     rezervuarM
            btfss       rezervuarM,1;    1
            goto        bbb3        ;  0  bbb3
            btfsc       rezervuarM,0;  1    0
            clrf        rezervuarM  ;  1  rezervuarM
            goto        bbb3        ;   bbb3
bbb2        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_rezer ;    KLAVA_rezer
;***************************************************************************************
;       1 
;***************************************************************************************
OPRO_NIZ1   movlw       .80         ;   80   Niz -
            movwf       Niz         ;    10
            movlw       .103        ; ------------------------------------------------------
            movwf       d1          ;
            movlw       .67         ;
            movwf       d2          ;   dn1 
            clrf        d4          ;
            movlw       60h         ;
            movwf       d3          ; ------------------------------------------------------
            movf        Udn1L,W     ;    W   Udn1L
            movwf       TimerL      ;    W   TimerL
            movf        Udn1M,W     ;    W   Udn1M
            movwf       TimerM      ;    W   TimerM
            call        Bin2_10     ;    Bin2_10_1
            call        NEW1        ;    NEW 
            call        screen      ;    
KLAVA_N1    btfss       PortB,2     ;    2 
            goto        Niz_plus1   ;  .   Niz_plus1
            btfss       PortB,1     ;   .   1
            goto        Niz_minus1  ;  .   Niz_minus1
            call        Vremya      ;    Vremya
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_N1    ;    KLAVA_N
            bcf         IntCon,7    ;  1      Udn1L  EEPROM
            bsf         Status,5    ;   1.
            movlw       2           ; ,   W,  02h.
            movwf       EEAdr       ;   02h,   W,   EEAdr.
            movf        Udn1L,W     ;  ,   Udn1L,   W.
            call        zapis       ;    zapis
            bsf         Status,5    ;   1.
            movlw       0           ; ,   W,  0h.
            movwf       EEAdr       ;   0h,   W,   EEAdr.
            movf        Udn1M,W     ;  ,   Udn1M,   W.
            call        zapis       ;    zapis
            goto        OPRO_VER1   ;    OPRO_VER 
;--------------------------------------------------------------------------------------------  
;          EEPROM  1  
;--------------------------------------------------------------------------------------------
Niz_minus1  call        Vremya      ;    Vremya    
            movlw       .1          ;  1  W
            bsf         Status,C    ;     1
            subwf       Udn1L,F     ;   1  Udn1L      .
            btfss       Status,C    ;   
            goto        bbb4        ;  0  bbb4
bbb7        movf        Udn1L,W     ;    W   Udn1L
            movwf       TimerL      ;    W   TimerL
            movf        Udn1M,W     ;    W   Udn1M
            movwf       TimerM      ;    W   TimerM
            goto        bbb5        ;   bbb5
bbb4        decf        Udn1M,F     ;     Udn1M
            btfsc       Udn1M,7     ;    7
            goto        bbb6        ;  1   bbb6
            goto        bbb7        ;   bbb7
bbb5        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_N1    ;    KLAVA_N1
bbb6        movlw       .2          ;--------------------------------------------------------
            movwf       Udn1M       ;   767    Udn1
            movlw       .255        ;
            movwf       Udn1L       ;--------------------------------------------------------
            goto        bbb7        ;   bbb7
;--------------------------------------------------------------------------------------------  
;            EEPROM  1  
;--------------------------------------------------------------------------------------------
Niz_plus1   call        Vremya      ;    Vremya    
            bcf         Status,Z    ;   Z
            incf        Udn1L,F     ;   1  Udn1L      .
            btfsc       Status,Z    ;    Z
            goto        bbb8        ;  0   bbb8
bbb0        movf        Udn1L,W     ;    W   Udn1L
            movwf       TimerL      ;    W   TimerL
            movf        Udn1M,W     ;    W   Udn1M
            movwf       TimerM      ;    W   TimerM
            goto        bbb9        ;   bbb9
bbb8        incf        Udn1M,F     ;     Udn1M
            btfss       Udn1M,1     ;    1
            goto        bbb0        ;  0   bbb0
            btfsc       Udn1M,0     ;  1    0
            clrf        Udn1M       ;  1  Udn1M
            goto        bbb0        ;   bbb0
bbb9        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_N1    ;    KLAVA_N1
;--------------------------------------------------------------------------------
;       1 
;--------------------------------------------------------------------------------
OPRO_VER1   movlw       .80         ;   80   Niz -
            movwf       Niz         ;    10
            movlw       .70         ;------------------------------------------------------------
            movwf       d1          ;
            movlw       .171        ;
            movwf       d2          ;   up1
            clrf        d4          ;
            movlw       60h         ;
            movwf       d3          ; -----------------------------------------------------------
            movf        Uup1L,W     ;    W   Uup1L
            movwf       TimerL      ;    W   TimerL
            movf        Uup1M,W     ;    W   Uup1M
            movwf       TimerM      ;    W   TimerM
            call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1 
            call        screen      ;    
KLAVA_V1    btfss       PortB,2     ;    2
            goto        Ver_plus1   ;  .   Ver_plus1
            btfss       PortB,1     ;   .   1
            goto        Ver_minus1  ;  .   Ver_minus1
            call        Vremya      ;    Vremya          
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_V1    ;    KLAVA_V1
            bsf         Status,5    ;   1.
            movlw       1           ; ,   W,  01h.
            movwf       EEAdr       ;   01h,   W,   EEAdr.
            movf        Uup1L,W     ;  ,   Uup1L,   W.
            call        zapis       ;    zapis
            bsf         Status,5    ;   1.
            movlw       7           ; ,   W,  07h.
            movwf       EEAdr       ;   07h,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        Uup1M,W     ;  ,   Udn1M,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
            goto        OPRO_NIZ2   ;    OPRO_NIZ2
;--------------------------------------------------------------------------------------------  
;                           EEPROM   
;--------------------------------------------------------------------------------------------
Ver_minus1  call        Vremya      ;    Vremya     
            movlw       .1          ;  1  W
            bsf         Status,C    ;     1
            subwf       Uup1L,F     ;   1  Uup1L      .
            btfss       Status,C    ;   
            goto        ccc0        ;  0   ccc0
ccc3        movf        Uup1L,W     ;    W   Uup1L
            movwf       TimerL      ;    W   TimerL
            movf        Uup1M,W     ;    W   Uup1M
            movwf       TimerM      ;    W   TimerM
            goto        ccc1        ;   ccc1
ccc0        decf        Uup1M,F     ;     Uup1M
            btfsc       Uup1M,7     ;    7
            goto        ccc2        ;  1   ccc2
            goto        ccc3        ;   ccc3
ccc1        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_V1    ;    KLAVA_V1
ccc2        movlw       .2          ;------------------------------------------------
            movwf       Uup1M       ;   767    Uup1
            movlw       .255        ;
            movwf       Uup1L       ;------------------------------------------------
            goto        ccc3       ;   ccc3
;--------------------------------------------------------------------------------------------  
;                           EEPROM   
;--------------------------------------------------------------------------------------------
Ver_plus1   call        Vremya      ;    Vremya    
            bcf         Status,Z    ;   Z
            incf        Uup1L,F     ;   1  Uup1L      .
            btfsc       Status,Z    ;    Z
            goto        ccc4        ;  0   ccc4 
ccc6        movf        Uup1L,W     ;    W   Uup1L
            movwf       TimerL      ;    W   TimerL
            movf        Uup1M,W     ;    W   Uup1M
            movwf       TimerM      ;    W   TimerM
            goto        ccc5        ;   ccc5
ccc4        incf        Uup1M,F     ;     Uup1M
            btfss       Uup1M,1     ;    1
            goto        ccc6        ;  0   ccc6
            btfsc       Uup1M,0     ;  1    0
            clrf        Uup1M       ;  1  Uup1M
            goto        ccc6        ;   ccc6
ccc5        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_V1    ;    KLAVA_V1
;*********************************************************************************
;     NIZ2
;*********************************************************************************
OPRO_NIZ2   movlw       .80         ;   80   Niz -
            movwf       Niz         ;    10
            movlw       .103        ; -----------------------------------------------
            movwf       d1          ;
            movlw       .67         ;
            movwf       d2          ;   dn2
            clrf        d4          ;
            movlw       02Fh        ;
            movwf       d3          ; -----------------------------------------------
            movf        Udn2L,W     ;    W   Udn2L
            movwf       TimerL      ;    W   TimerL
            movf        Udn2M,W     ;    W   Udn2M
            movwf       TimerM      ;    W   TimerM
            call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
KLAVA_N2    btfss       PortB,2     ;    2
            goto        Niz_plus2   ;  .   Niz_plus2
            btfss       PortB,1     ;   .   1
            goto        Niz_minus2  ;  .   Niz_minus2
            call        Vremya      ;    Vremya
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_N2    ;    KLAVA_N2
            bsf         Status,5    ;   1.
            movlw       5           ; ,   W,  05h.
            movwf       EEAdr       ;   05h,   W,   EEAdr.
            movf        Udn2L,W     ;  ,   Udn2L,   W.
            call        zapis       ;    zapis
            bsf         Status,5    ;   1.
            movlw       3           ; ,   W,  03h.
            movwf       EEAdr       ;   03h,   W,   EEAdr.
            movf        Udn2M,W     ;  ,   Udn2M,   W.
            call        zapis       ;    zapis
            goto        OPRO_VER2   ;    OPRO_VER2
;--------------------------------------------------------------------------------------------  
;                           EEPROM  2  
;--------------------------------------------------------------------------------------------
Niz_minus2  call        Vremya      ;    Vremya    
            movlw       .1          ;  1  W
            bsf         Status,C    ;     1 
            subwf       Udn2L,F     ;   1  Udn2L      .
            btfss       Status,C    ;   
            goto        ccc7        ;  0   ccc7
ddd0        movf        Udn2L,W     ;    W   Udn2L
            movwf       TimerL      ;    W   TimerL
            movf        Udn2M,W     ;    W   Udn2M
            movwf       TimerM      ;    W   TimerM
            goto        ccc8        ;   ccc8
ccc7        decf        Udn2M,F     ;     Udn2M
            btfsc       Udn2M,7     ;    7
            goto        ccc9        ;  1   ccc9
            goto        ddd0        ;   20  
ccc8        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_N2    ;    KLAVA_N
ccc9        movlw       .2          ;------------------------------------------------
            movwf       Udn2M       ;   767    Uup2
            movlw       .255        ; 
            movwf       Udn2L       ; ------------------------------------------------
            goto        ddd0        ;   ddd0
;--------------------------------------------------------------------------------------------  
;                           EEPROM   
;--------------------------------------------------------------------------------------------
Niz_plus2   call        Vremya      ;    Vremya    
            bcf         Status,Z    ;   Z 
            incf        Udn2L,F     ;   1  Udn      .
            btfsc       Status,Z    ;    Z
            goto        ddd1        ;  0   ddd1
ddd3        movf        Udn2L,W     ;    W   Udn2L
            movwf       TimerL      ;    W   TimerL
            movf        Udn2M,W     ;    W   Udn2M
            movwf       TimerM      ;    W   TimerM
            goto        ddd2        ;   ddd2
ddd1        incf        Udn2M,F     ;     Udn2M
            btfss       Udn2M,1     ;    1
            goto        ddd3        ;  0   ddd3
            btfsc       Udn2M,0     ;  1    0
            clrf        Udn2M       ;  1  Udn2M
            goto        ddd3        ;   ddd3
ddd2        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_N2    ;    KLAVA_N
;--------------------------------------------------------------------------------
;     VER2
;--------------------------------------------------------------------------------
OPRO_VER2   movlw       .80         ;   80   Niz -
            movwf       Niz         ;    10
            movlw       .70         ; ---------------------------------------------------
            movwf       d1          ;
            movlw       .171        ; 
            movwf       d2          ;    up2
            clrf        d4          ;
            movlw       02Fh        ;
            movwf       d3          ; --------------------------------------------------- 
            movf        Uup2L,W     ;    W   Uup2L
            movwf       TimerL      ;    W   TimerL
            movf        Uup2M,W     ;    W   Uup
            movwf       TimerM      ;    W   Timer
            call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
KLAVA_V2    btfss       PortB,2     ;    2 
            goto        Ver_plus2   ;  .   Ver_plus2
            btfss       PortB,1     ;   .   1
            goto        Ver_minus2  ;  .   Ver_minus2
            call        Vremya      ;    Vremya     
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLAVA_V2    ;    KLAVA_V
            bsf         Status,5    ;   1.
            movlw       4           ; ,   W,  04h.
            movwf       EEAdr       ;   04h,   W,   EEAdr.
            movf        Uup2L,W     ;  ,   Uup2L,   W.
            call        zapis       ;    zapis
            bsf         Status,5    ;   1.
            movlw       8           ; ,   W,  08h.
            movwf       EEAdr       ;   08h,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        Uup2M,W     ;  ,   Udn2,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
	goto	OT_ZAK

;--------------------------------------------------------------------------------------------  
;                           EEPROM   
;--------------------------------------------------------------------------------------------
Ver_minus2  call        Vremya      ;    Vremya     
            movlw       .1          ;  1  W
            bsf         Status,C    ;     1
            subwf       Uup2L,F     ;   1  Uup      .
            btfss       Status,C    ;   
            goto        ddd4        ;  0   ddd4
ddd7        movf        Uup2L,W     ;    W   Uup2L
            movwf       TimerL      ;    W   TimerL
            movf        Uup2M,W     ;    W   Uup2M
            movwf       TimerM      ;    W   TimerM
            goto        ddd5        ;   ddd5
ddd4        decf        Uup2M,F     ;     Uup2M
            btfsc       Uup2M,7     ;    7
            goto        ddd6        ;  1   ddd6
            goto        ddd7        ;   ddd7
ddd5        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW1
            call        screen      ;    
            goto        KLAVA_V2    ;    KLAVA_V2
ddd6        movlw       .2          ;------------------------------------------------
            movwf       Uup2M       ;   767    Uup2
            movlw       .255        ;
            movwf       Uup2L       ;-------------------------------------------------
            goto        ddd7        ;   ddd7
;--------------------------------------------------------------------------------------------  
;         EEPROM  2  
;--------------------------------------------------------------------------------------------
Ver_plus2   call        Vremya      ;    Vremya    
            bcf         Status,Z    ;   Z            
            incf        Uup2L,F     ;   1  Uup2L      .
            btfsc       Status,Z    ;    Z
            goto        ddd8        ;   ddd8     
eee0        movf        Uup2L,W     ;    W   Uup2L
            movwf       TimerL      ;    W   TimerL
            movf        Uup2M,W     ;    W   Uup2M
            movwf       TimerM      ;    W   TimerM
            goto        ddd9        ;   ddd9
ddd8        incf        Uup2M,F     ;     Uup2M
            btfss       Uup2M,1     ;    1 
            goto        eee0        ;  0   eee0
            btfsc       Uup2M,0     ;  1    0
            clrf        Uup2M       ;  1  Uup2M
            goto        eee0        ;   eee0
ddd9        call        Bin2_10     ;    Bin2_10
            call        NEW1        ;    NEW
            call        screen      ;    
            goto        KLAVA_V2    ;    KLAVA_V 

;*********************************************************************************
;       -    
;*********************************************************************************
OT_ZAK      movlw       .80         ;   80   Niz -
            movwf       Niz         ;    8
            movlw       .238        ; -----------------------------------------------------
            movwf       d1          ;
            movlw       .1          ;   O-3
            movwf       d2          ;
            movlw       .109        ; 
            movwf       d3          ;
	clrf	d6	;
	clrf	d7	; ------------------------------------------------------
            btfss       setup,1     ;   0
            goto        aaa1        ;  0   15  
            movlw       60h         ;  1   .96  W
aaa2        movwf       d8          ;     W,   d8.
            call        screen      ;    
KLA_OTZAK   btfss       PortB,2     ;    2
            goto        OTZAK_plus  ;  .   obhod_plus
            btfss       PortB,1     ;   .   1
            goto        OTZAK_minus ;  .   obhod_minus
            call        Vremya      ;    Vremya
            clrwdt                  ;  wdt
            decfsz      Niz,F       ;   1  Niz
            goto        KLA_OTZAK   ;    KLAVA_obhod
            bsf         Status,5    ;   1.
            movlw       6           ; ,   W,  06h.
            movwf       EEAdr       ;   06h,   W,   EEAdr.
            bcf         Status,5    ;   0.
            movf        setup,W     ;  ,   setup,   W.
            bsf         Status,5    ;   1.
            call        zapis       ;    zapis
yyyy0       swapf       TempD1,W    ; ---------------------------- 
            movwf       d1          ;
            swapf       TempD3,W    ;  
            movwf       d3          ;  d1-d4   
	clrf	d2
	clrf	d6	;
	clrf	d7	;
	clrf	d8	; -----------------------------
            movlw       .10         ;  10       
            movwf       ABD         ;       
            bcf         Flag,1      ; -----------------------------------------------
            bcf         Flag,4      ;
            bcf         Flag,5      ;   
            bcf         Flag,6      ;
            bcf         Flag,7      ;
            clrf        nakopitL    ;   RezultL+RezultL+RezultL=nakopitL
            clrf        nakopitM    ;   RezultM+RezultM+RezultM=nakopitM
            goto        OPROS       ;    OPROS
;--------------------------------------------------------------------------------------------
aaa1        movlw       0EEh        ;   .238  W 
            goto        aaa2        ;   41  
;--------------------------------------------------------------------------------------------
;          EEPROM   -    
;--------------------------------------------------------------------------------------------
OTZAK_minus call        Vremya      ;    Vremya       
            bcf         setup,1     ;    0  0 (  -)
            movlw       0EEh        ;   .238  W 
            movwf       d8          ;     W,   d8.
            call        screen      ;    
            goto        KLA_OTZAK   ;    KLA_OTZAK
;--------------------------------------------------------------------------------------------
;          EEPROM   -    
;--------------------------------------------------------------------------------------------
OTZAK_plus  call        Vremya      ;    Vremya       
            bsf         setup,1     ;    0  1 (  -) 
            movlw       .109        ;   .96  W 
            movwf       d8          ;     W,   d8.
            call        screen      ;    
            goto        KLA_OTZAK   ;    KLA_OTZAK
;--------------------------------------------------------------------------------------------
            end                     ;  .












